/***
 * Excerpted from "Modern Systems Programming with Scala Native",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/rwscala for more book information.
***/
def parseLine(line_in:CString, word_out:CString, buffer_size:Int):Unit = {
  val temp_buffer= stackalloc[Byte](1024)
  val max_word_length = buffer_size - 1
  val scanResult = stdio.sscanf(line, c"%1023s\n", temp_buffer)
  if (scanResult < 1) {
    throw new Exception(s"bad scanf result: $scanResult")    
  }
  val word_length = strlen(temp_buffer)
  if (word_length >= max_word_length) {
    throw new Exception(
      s"word length $word_length exceeds max buffer size $buffer_size")
  }
  strncpy(word_out, word_length, temp_buffer)
}

def main(args:Array[String]):Unit = {
  val line_in_buffer = stackalloc[Byte](1024)
  val word_out_buffer = stackalloc[Byte](32)
  while (fgets(line_in_buffer, 1023, stdin) != null) {
    parseLine(line_in_buffer, word_out_buffer, 32)
    printf(c"read word: '%s'\n", word_out_buffer)
  }
}